rm(list = ls()) # Clear workspace 
cat("\014") # Clear console

# Demo 3: Predictive Maintenance mit R 

# 0 Pakete importieren ----
# Lade benötigte Pakete
library(rpart)
library(rpart.plot)


# 1 Datenvorbereitung ----
# Lese CSV-Datei und speichere 
# sie unter dem Namen "demo3"
demo3=read.csv2("automotive_data_140.csv", 
                header = TRUE, sep = ";",dec = ".")


# Wähle Merkmale aus
# Erstelle Trainingsdaten demo3training
demo3training=demo3[ , c(-1,-25)]

# Überprüfe die Struktur von demo3training
str(demo3training)

# 2 Modell erstellen und trainieren ----
# Erstelle Entscheidungsbaum 
# mit dem CART-Algorithmus

fit = rpart(Ausfall ~ .,   
            data=demo3training,               
            method="class",                   
            parms=list( split="information"),
            control=list( minsplit=15)) 

# Gebe den Baum in Textform aus
print(fit)  

# Erstelle die Grafik des Baums
# mit rpart.plot
dt = rpart.plot(fit, type = 1, extra = 1, 
                uniform=TRUE, 
                main="Entscheidungsbaum für Ausfall-Klassifikation")


# 3 Vorhersage ----
# Demo 3: Predictive Maintenance mit R 

# Lese CSV-Datei und speichere sie
# unter dem Namen "demo3test"
demo3test=read.csv2("automotive_data_test_4.csv", 
                    header = TRUE,sep = ";",dec = ".")

# Erstelle Testdaten testdata aus demo3test
# ohne die Variable Messungsnummer 
testdata=demo3test[ ,c(-1)]                              

# Vorhersage für die Testdaten/neue Beobachtungen
pred = predict(fit, newdata=testdata, type="class")
pred

# Füge die vorhergesagten Werte in die Spalte Ausfall ein
demo3test$Ausfall = as.vector(pred)
demo3test
